import * as tslib_1 from "tslib";
import * as React from 'react';
import { concatStyleSets } from 'office-ui-fabric-react/lib/Styling';
export function styled(Component, styleMethods) {
    return function (componentProps) {
        var allStyleMethods = {};
        var _loop_1 = function (methodName) {
            if (styleMethods.hasOwnProperty(methodName)) {
                var method_1 = styleMethods[methodName];
                allStyleMethods[methodName] = function (styleProps) { return concatStyleSets(method_1 && method_1(styleProps), componentProps[methodName] && componentProps[methodName](styleProps)); };
            }
        };
        for (var methodName in styleMethods) {
            _loop_1(methodName);
        }
        return (React.createElement(Component, tslib_1.__assign({}, componentProps, allStyleMethods)));
    };
}
//# sourceMappingURL=styled.js.map