/// <reference types="react" />
import * as React from 'react';
export interface IPropsWithStyles<TStyleProps, TStyles> {
    getStyles?: (props?: TStyleProps) => Partial<TStyles>;
}
export declare function styled<TComponentProps extends IPropsWithStyles<TStyleProps, TStyles>, TStyleProps, TStyles>(Component: React.ComponentClass<TComponentProps> | React.StatelessComponent<TComponentProps>, styleMethods: {
    [key in keyof TComponentProps]?: TComponentProps[key];
}): (props: TComponentProps) => JSX.Element;
