"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var Styling_1 = require("office-ui-fabric-react/lib/Styling");
function styled(Component, styleMethods) {
    return function (componentProps) {
        var allStyleMethods = {};
        var _loop_1 = function (methodName) {
            if (styleMethods.hasOwnProperty(methodName)) {
                var method_1 = styleMethods[methodName];
                allStyleMethods[methodName] = function (styleProps) { return Styling_1.concatStyleSets(method_1 && method_1(styleProps), componentProps[methodName] && componentProps[methodName](styleProps)); };
            }
        };
        for (var methodName in styleMethods) {
            _loop_1(methodName);
        }
        return (React.createElement(Component, tslib_1.__assign({}, componentProps, allStyleMethods)));
    };
}
exports.styled = styled;
//# sourceMappingURL=styled.js.map