"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var Icon_types_1 = require("./Icon.types");
var Image_1 = require("../Image/Image");
var Utilities_1 = require("../../Utilities");
var Styling_1 = require("../../Styling");
var getClassNames = Styling_1.classNamesFunction();
exports.IconBase = function (props) {
    var ariaLabel = props.ariaLabel, _a = props.as, RootType = _a === void 0 ? 'i' : _a, className = props.className, getStyles = props.getStyles, iconName = props.iconName, iconType = props.iconType;
    var iconDefinition = Styling_1.getIcon(iconName) || {
        subset: {
            className: undefined,
        },
        code: undefined
    };
    var classNames = getClassNames(getStyles, {
        className: className,
        isPlaceholder: typeof iconName === 'string' && iconName.length === 0,
        isImage: iconType === Icon_types_1.IconType.image,
        subsetClassName: iconDefinition.subset.className
    });
    return (React.createElement(RootType, tslib_1.__assign({}, Utilities_1.getNativeProps(props, Utilities_1.htmlElementProperties), { className: classNames.root, role: 'presentation', "aria-hidden": 'true', "aria-label": ariaLabel }, (ariaLabel ? {} : { 'aria-hidden': true }), { "data-icon-name": iconName || '' }),
        iconType === Icon_types_1.IconType.image && (React.createElement(Image_1.Image, tslib_1.__assign({}, props.imageProps))),
        iconDefinition.code));
};
//# sourceMappingURL=Icon.base.js.map