"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Image_types_1 = require("./Image.types");
var Styling_1 = require("../../Styling");
var OneHundredPercent = '100%';
var Auto = 'auto';
exports.getStyles = function (props) {
    var className = props.className, imageFit = props.imageFit, loadState = props.loadState, isPortrait = props.isPortrait, maximizeFrame = props.maximizeFrame, width = props.width, height = props.height, shouldFadeIn = props.shouldFadeIn;
    var isLoaded = loadState === Image_types_1.ImageLoadState.loaded;
    var isError = loadState === Image_types_1.ImageLoadState.error;
    var isBestFit = imageFit === undefined;
    var scaleWidth = isBestFit && width !== undefined && height === undefined;
    var scaleHeight = isBestFit && width === undefined && height !== undefined;
    var scaleWidthHeight = isBestFit && width !== undefined && height !== undefined;
    return {
        root: [
            'ms-Image',
            {
                overflow: 'hidden'
            },
            maximizeFrame && {
                height: OneHundredPercent,
                width: OneHundredPercent
            },
            className
        ],
        image: [
            'ms-Image-image',
            isPortrait && 'ms-Image-image--portrait',
            !isPortrait && 'ms-Image-image--landscape',
            imageFit === Image_types_1.ImageFit.none && 'ms-Image-image--none',
            imageFit === Image_types_1.ImageFit.center && 'ms-Image-image--center',
            imageFit === Image_types_1.ImageFit.contain && 'ms-Image-image--contain',
            imageFit === Image_types_1.ImageFit.cover && 'ms-Image-image--cover',
            !isLoaded && 'is-notLoaded',
            isLoaded && 'is-loaded ',
            shouldFadeIn && 'is-fadeIn',
            loadState === Image_types_1.ImageLoadState.error && 'is-error',
            scaleWidth && 'ms-Image-image--scaleWidth',
            scaleHeight && 'ms-Image-image--scaleHeight',
            scaleWidthHeight && 'ms-Image-image--scaleWidthHeight',
            {
                display: 'block',
                opacity: 0
            },
            isLoaded && {
                opacity: 1
            },
            isLoaded && shouldFadeIn && Styling_1.AnimationClassNames.fadeIn400,
            (imageFit === Image_types_1.ImageFit.center ||
                imageFit === Image_types_1.ImageFit.contain ||
                imageFit === Image_types_1.ImageFit.cover) && {
                position: 'relative',
                left: '50%',
                top: '50%',
                transform: 'translate(-50%, -50%)'
            },
            imageFit === Image_types_1.ImageFit.contain && [
                !isPortrait && {
                    width: OneHundredPercent,
                    height: Auto
                },
                isPortrait && {
                    width: Auto,
                    height: OneHundredPercent
                }
            ],
            imageFit === Image_types_1.ImageFit.cover && [
                !isPortrait && {
                    height: OneHundredPercent,
                    width: Auto
                },
                isPortrait && {
                    width: OneHundredPercent,
                    height: Auto
                }
            ],
            scaleWidthHeight && {
                width: OneHundredPercent,
                height: OneHundredPercent
            },
            scaleWidth && {
                width: OneHundredPercent,
                height: Auto
            },
            scaleHeight && {
                width: Auto,
                height: OneHundredPercent
            }
        ]
    };
};
//# sourceMappingURL=Image.styles.js.map